theory Fresh
imports "~~/src/HOL/Library/Infinite_Set"
begin

lemma ex_fresh:
  assumes "infinite A" and "finite B"
  shows "\<exists>a. a \<in> A - B"
using assms(2, 1)
proof (induction arbitrary: A)
  case empty
  then show ?case by (metis Diff_empty all_not_in_conv finite.emptyI)
next
  case (insert b B)
  then have "infinite (A - {b})" by (metis infinite_remove)
  from insert.IH [OF this]
    show ?case by simp
qed

lemma disj_fresh_vars:
  assumes "infinite V" and "finite T"
  shows "\<exists>xs. length xs = n \<and> distinct xs \<and> set xs \<subseteq> V - T" (is "\<exists>xs. ?P n xs")
proof (induct n)
  case (Suc n)
  with assms obtain xs where "length xs = n"
    and "distinct xs" and "set xs \<subseteq> V - T"
    and "finite (T \<union> set xs)" by auto
  moreover with ex_fresh [OF `infinite V` `finite (T \<union> set xs)`]
    obtain x where "x \<in> V - (T \<union> set xs)" by blast
  ultimately have "?P (Suc n) (x # xs)" by auto
  then show ?case ..
qed simp

lemma fresh_vars:
  assumes "infinite V"
  shows "\<exists>xs. length xs = n \<and> distinct xs \<and> set xs \<subseteq> V"
  using disj_fresh_vars [OF assms, of "{}"] by simp

end

